package cc.fascinated.model.score.impl.scoresaber;

import cc.fascinated.model.score.DeviceInformation;
import cc.fascinated.model.score.Score;
import cc.fascinated.platform.Platform;
import lombok.Getter;

import java.util.Date;

/**
 * @author Fascinated (fascinated7)
 */
@Getter
public class ScoreSaberScore extends Score {
    /**
     * The weight of the score.
     */
    private final Double weight;

    /**
     * The multiplier of the score.
     */

    private final double multiplier;
    /**
     * The maximum combo achieved in the score.
     */
    private final int maxCombo;

    public ScoreSaberScore(long id, String playerId, Platform.Platforms platform, String platformScoreId, String leaderboardId, int rank,
                           double accuracy, Double pp, int score, String[] modifiers, Integer misses, Integer badCuts, DeviceInformation deviceInformation,
                           Date timestamp, Double weight, double multiplier, int maxCombo) {
        super(id, playerId, platform, platformScoreId, leaderboardId, rank, accuracy, pp, score, modifiers, misses,
                badCuts, deviceInformation, timestamp);
        this.weight = weight;
        this.multiplier = multiplier;
        this.maxCombo = maxCombo;
    }

    /**
     * Gets the modified score.
     *
     * @return the modified score
     */
    public int getModifiedScore() {
        if (multiplier == 1) {
            return getScore();
        }
        return (int) (getScore() * multiplier);
    }

    /**
     * Gets the weight of the score.
     *
     * @return the weight of the score
     */
    public Double getWeight() {
        return weight == null ? 0 : weight;
    }
}
