package cc.fascinated.model.token.steam;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Getter;

/**
 * @author Fascinated (fascinated7)
 */
@Getter
public class SteamAuthenticateUserTicketToken {
    /**
     * The response from the Steam API.
     */
    private Response response;

    @Getter
    public static class Response {
        /**
         * The params of the response.
         */
        private Params params;

        @Getter
        public static class Params {
            /**
             * The result of the request.
             */
            private String result;

            /**
             * The steam id of the user.
             */
            @JsonProperty("steamid")
            private String steamId;

            /**
             * The owner steam id of the user.
             */
            @JsonProperty("ownersteamid")
            private String ownerSteamId;

            /**
             * The vac banned status of the user.
             */
            @JsonProperty("vacbanned")
            private boolean vacBanned;

            /**
             * The publisher banned status of the user.
             */
            @JsonProperty("publisherbanned")
            private boolean publisherBanned;
        }
    }
}
